import tester.*;

interface IList {
  int size();
  IList getRest();
  //boolean isEmpty();
  boolean contains( String n );
}

class Empty implements IList {
  Empty(){}
  
  public IList getRest() {
    throw new Error("empty list does not have a rest.");
  }
  
  public boolean contains(String n ) {
    return false;
  }
  
  public int size() {
    return 0;
  }
}

class MyCons implements IList {
  String first;
  IList rest;
  
  MyCons( String _first, IList _rest) {
    this.first = _first;
    this.rest = _rest;
  }
  
  public IList getRest() {
    return this.rest;
  }
  
  public boolean contains(String n ) {
    if (this.first.equals(n)) {
      return true;
    }else {
      return this.rest.contains(n);
    }
  }
  
  public int size() {
    return 1 + this.rest.size();
  }
}
    
class Examples {
  
  Examples(){}
  
  void testIList( Tester t ) {
    IList myList = new MyCons("23", new MyCons("65", new MyCons("2", new Empty())));
	IList myList2 = new MyCons(new String("23"), 
					new MyCons(new String("65"), 
					new MyCons(new String("2"), 
					new Empty())));
					
    t.checkExpect(myList.size(), 3);
    t.checkExpect(myList.contains(new String("65")), true);
    t.checkExpect(myList.contains(new String("100")), false);
	
	// This following test shows that checkExpect tests for extensional equality.
	t.checkExpect(myList, myList2);
  }
}
  
  
  
  

  